/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.GrpacessoRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Grpacesso extends TableImpl<GrpacessoRecord> {

    private static final long serialVersionUID = -1369787197;

    /**
     * The reference instance of <code>public.grpacesso</code>
     */
    public static final Grpacesso GRPACESSO = new Grpacesso();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<GrpacessoRecord> getRecordType() {
        return GrpacessoRecord.class;
    }

    /**
     * The column <code>public.grpacesso.grpid</code>.
     */
    public final TableField<GrpacessoRecord, Integer> GRPID = createField("grpid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('grpacesso_grpid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.grpacesso.grpdescricao</code>.
     */
    public final TableField<GrpacessoRecord, String> GRPDESCRICAO = createField("grpdescricao", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * The column <code>public.grpacesso.grpativo</code>.
     */
    public final TableField<GrpacessoRecord, Boolean> GRPATIVO = createField("grpativo", org.jooq.impl.SQLDataType.BOOLEAN, this, "");

    /**
     * Create a <code>public.grpacesso</code> table reference
     */
    public Grpacesso() {
        this(DSL.name("grpacesso"), null);
    }

    /**
     * Create an aliased <code>public.grpacesso</code> table reference
     */
    public Grpacesso(String alias) {
        this(DSL.name(alias), GRPACESSO);
    }

    /**
     * Create an aliased <code>public.grpacesso</code> table reference
     */
    public Grpacesso(Name alias) {
        this(alias, GRPACESSO);
    }

    private Grpacesso(Name alias, Table<GrpacessoRecord> aliased) {
        this(alias, aliased, null);
    }

    private Grpacesso(Name alias, Table<GrpacessoRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.GRPACESSO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<GrpacessoRecord, Integer> getIdentity() {
        return Keys.IDENTITY_GRPACESSO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<GrpacessoRecord> getPrimaryKey() {
        return Keys.GRPACESSO_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<GrpacessoRecord>> getKeys() {
        return Arrays.<UniqueKey<GrpacessoRecord>>asList(Keys.GRPACESSO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Grpacesso as(String alias) {
        return new Grpacesso(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Grpacesso as(Name alias) {
        return new Grpacesso(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Grpacesso rename(String name) {
        return new Grpacesso(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Grpacesso rename(Name name) {
        return new Grpacesso(name, null);
    }
}
